#include <sourcemod>
#include <sdktools>
#include <multicolors>
#include <autoexecconfig>
#include <sdkhooks>
#include <cstrike>
#include <adminmenu>
#include <calladmin>
#include <PTaH>
#include <dhooks>
#include <printvalvetranslation>

#pragma semicolon 1

#define DEBUG

#pragma newdecls required

//==========================================================================================================================
//
// Thanks to the owners of these plugins
// 
// Admin STEALTH - https://forums.alliedmods.net/showthread.php?p=2499417 - By Potatoz
// Esl Admin ESP - https://forums.alliedmods.net/showthread.php?p=2630710 - By sazonische
// Command Hider - https://forums.alliedmods.net/showthread.php?t=274465 - By ZipCore
// S2AProxy - https://forums.alliedmods.net/showthread.php?t=335736 - By poggu
// Print Valve Translation - https://forums.alliedmods.net/showthread.php?t=314096 - By Powerlord
//
//==========================================================================================================================

public Plugin myinfo = 
{
	name = "STAFF Modes", 
	author = "LanteJoula", 
	description = "STAFF Modes - Fake Leave and Join Server for Staff with Chat Message and Wall Hack", 
	version = "3.7", 
	url = "https://steamcommunity.com/id/lantejoula/"
};

// CONVARS

char g_ChatPrefix[256];
ConVar gConVar_Chat_Prefix;

ConVar gConVar_Staffs_Name_List;

ConVar gConVar_Join_Leave_Message_Type;

ConVar gConVar_Join_Leave_StaffMode;

ConVar gConVar_StatusPing;

//STAFF EM STAFF MODE ARRAY

ArrayList staffemstaffmodes;

Handle hHudText;

// STEALTH

bool g_bHideMe[MAXPLAYERS + 1] = { false, ... };

int g_iPlayerManager;
int g_iConnectedOffset;
int g_iAliveOffset;
int g_iTeamOffset;
int g_iPingOffset;
int g_iScoreOffset;
int g_iDeathsOffset;
int g_iHealthOffset;

ConVar sm_stealth_autoswitch;
ConVar sm_stealth_disable_switch;

// WALLHACK

ConVar sv_competitive_official_5v5;

// ADMIN MENU

Handle hAdminMenu;

// PICKING TEAM MENU

bool PickingMenu[MAXPLAYERS + 1] = false;

// MODES MENU

bool StaffModes[MAXPLAYERS + 1] = true;

// REMOVE STAFF NICKSNAMES ON COMMUNITYT SERVERS LIST

int g_platform;
int ExcludeCountServer;

GlobalForward g_ExcludeForward;
GlobalForward g_ExcludeCountForward;

bool g_hideStaffList[MAXPLAYERS + 1] = false;

public void OnPluginStart()
{
	// TRANSLATIOSN
	
	LoadTranslations("staffmodes.phrases");
	
	// ADMIN MEN
	
	Handle topmenu;
	
	if (LibraryExists("adminmenu") && ((topmenu = GetAdminTopMenu()) != INVALID_HANDLE))
		OnAdminMenuReady(topmenu);
	
	// Open Menu
	
	RegAdminCmd("sm_staff", Staff_Mode, ADMFLAG_GENERIC);
	
	// CONVARS
	
	AutoExecConfig_SetFile("plugin.staffmodes");
	
	gConVar_Chat_Prefix = AutoExecConfig_CreateConVar("sm_staffmodes_chat_prefix", "[ {green}TAG {default}]", "Chat Prefix");
	
	gConVar_Staffs_Name_List = AutoExecConfig_CreateConVar("sm_staffmodes_staff_names_list", "3", "List with All Names of Staff that are on Staff Mode (0 - Disable | 1 - On Menu | 2 - On Score | 3 - On Tab and Score)", 0, true, 0.0, true, 3.0);
	
	gConVar_Join_Leave_Message_Type = AutoExecConfig_CreateConVar("sm_staffmodes_join_leave_message_type", "2", "Join and Leave Messages Type (0 - Disable | 1 - Valve Default White Messages | 2 - Custom Messages Translations)", 0, true, 0.0, true, 2.0);
	
	gConVar_Join_Leave_StaffMode = AutoExecConfig_CreateConVar("sm_staffmodes_join_staffmode_message", "1", "Enable/Disable the Message when Staff Join and Leave Staff Mode (1 - Enable | 0 - Disable)", 0, true, 0.0, true, 1.0);
	
	gConVar_StatusPing = AutoExecConfig_CreateConVar("sm_staffmodes_status_ping", "1", "Command 'status' and 'ping' (1 - Allow for STAFF and Block for others Players | 0 - Block for Everybody)", 0, true, 0.0, true, 1.0);
	
	AutoExecConfig_ExecuteFile();
	AutoExecConfig_CleanFile();
	
	gConVar_Chat_Prefix.AddChangeHook(OnPrefixChange);
	
	// STEALTH
	
	HookEvent("player_team", Event_OnPlayerTeam, EventHookMode_Pre);
	
	sm_stealth_autoswitch = AutoExecConfig_CreateConVar("sm_staffmodes_stealth_autoswitch", "1", "Automatically switch admins to spectators on Stealth?", FCVAR_DONTRECORD, true, 0.0, true, 1.0);
	sm_stealth_disable_switch = AutoExecConfig_CreateConVar("sm_staffmodes_stealth_disable_switch", "1", "Disable Stealth Mode on switch to other team? (If autoswitch is enabled)", FCVAR_DONTRECORD, true, 0.0, true, 1.0);
	
	g_iConnectedOffset = FindSendPropInfo("CCSPlayerResource", "m_bConnected");
	g_iAliveOffset = FindSendPropInfo("CCSPlayerResource", "m_bAlive");
	g_iTeamOffset = FindSendPropInfo("CCSPlayerResource", "m_iTeam");
	g_iPingOffset = FindSendPropInfo("CCSPlayerResource", "m_iPing");
	g_iScoreOffset = FindSendPropInfo("CCSPlayerResource", "m_iScore");
	g_iDeathsOffset = FindSendPropInfo("CCSPlayerResource", "m_iDeaths");
	g_iHealthOffset = FindSendPropInfo("CCSPlayerResource", "m_iHealth");
	
	// WALLHACK
	
	sv_competitive_official_5v5 = FindConVar("sv_competitive_official_5v5");
	
	// REMOVE STAFF NICKSNAMES ON COMMUNITYT SERVERS LIST
	
	GameData hGameConf;
	char error[128];
	
	hGameConf = LoadGameConfigFile("s2aproxy.games");
	
	if (!hGameConf)
	{
		Format(error, sizeof(error), "Failed to find s2aproxy.games");
		SetFailState(error);
	}
	
	g_platform = hGameConf.GetOffset("WindowsOrLinux");
	
	Handle hNetSendPacket = DHookCreateDetour(Address_Null, CallConv_CDECL, ReturnType_Int, ThisPointer_Ignore);
	
	if (!hNetSendPacket)
		SetFailState("Failed to setup detour for NET_SendPacket");
	
	if (!DHookSetFromConf(hNetSendPacket, hGameConf, SDKConf_Signature, "NET_SendPacket"))
		SetFailState("Failed to load NET_SendPacket signature from gamedata");
	
	if (g_platform == 1)
	{
		DHookAddParam(hNetSendPacket, HookParamType_Int, .custom_register = DHookRegister_EDX); // Windows call convention
		DHookAddParam(hNetSendPacket, HookParamType_ObjectPtr, -1, DHookPass_ByRef, DHookRegister_ECX);
	}
	else
	{
		DHookAddParam(hNetSendPacket, HookParamType_Int);
		DHookAddParam(hNetSendPacket, HookParamType_ObjectPtr, -1, DHookPass_ByRef);
	}
	
	DHookAddParam(hNetSendPacket, HookParamType_Int);
	DHookAddParam(hNetSendPacket, HookParamType_Int);
	DHookAddParam(hNetSendPacket, HookParamType_Int);
	
	if (!DHookEnableDetour(hNetSendPacket, false, Detour_OnNetSendPacket))
		SetFailState("Failed to detour NET_SendPacket.");
	
	delete hGameConf;
	
	g_ExcludeForward = new GlobalForward("OnClientPlayerList", ET_Event, Param_String);
	g_ExcludeCountForward = new GlobalForward("OnServerExcludeCount", ET_Event, Param_CellByRef);
	
	// TEAM PICKING
	
	HookEvent("player_team", Event_OnPlayerTeam1, EventHookMode_Post);
	
	// DISABLE PING AND STATUS ON CONSOLA
	
	PTaH(PTaH_ExecuteStringCommandPre, Hook, ExecuteStringCommand);
	
	// REMOVER MENSAGENS DEFAULT BRANCAS
	
	HookEvent("player_team", OnPlayerTeam1, EventHookMode_Pre);
	HookEvent("player_disconnect", OnPlayerDisconnect1, EventHookMode_Pre);
	
	//STAFF EM STAFF MODE ARRAY
	
	staffemstaffmodes = CreateArray(512);
	
	hHudText = CreateHudSynchronizer();
}

// PREFIX

public void SavePrefix()
{
	GetConVarString(gConVar_Chat_Prefix, g_ChatPrefix, sizeof(g_ChatPrefix));
}

public void OnConfigsExecuted()
{
	SavePrefix();
}

public void OnPrefixChange(ConVar cvar, char[] oldvalue, char[] newvalue)
{
	SavePrefix();
}

// ADMIN MENU

public void OnAllPluginsLoaded()
{
	Handle topmenu;
	if (LibraryExists("adminmenu") && ((topmenu = GetAdminTopMenu()) != null))
		OnAdminMenuReady(topmenu);
}

public void OnAdminMenuReady(Handle topmenu)
{
	if (topmenu == hAdminMenu)
		return;
	
	hAdminMenu = topmenu;
	CreateTimer(1.0, Timer_AttachAdminMenu);
}

public Action Timer_AttachAdminMenu(Handle timer)
{
	TopMenuObject menu_category = AddToTopMenu(hAdminMenu, "staffmodes", TopMenuObject_Category, Handle_Category, INVALID_TOPMENUOBJECT, "staffmodes", ADMFLAG_GENERIC);
	if (menu_category == INVALID_TOPMENUOBJECT)
		return;
	
	AddToTopMenu(hAdminMenu, "sm_staff", TopMenuObject_Item, AdminMenu_StaffMode, menu_category, "sm_staff", ADMFLAG_GENERIC);
}

public void Handle_Category(TopMenu topmenu, TopMenuAction action, TopMenuObject topobj_id, int param, char[] buffer, int maxlength)
{
	if (action == TopMenuAction_DisplayTitle)
		Format(buffer, maxlength, "%T", "Staff Mode Title in Admin", param);
	else if (action == TopMenuAction_DisplayOption)
		Format(buffer, maxlength, "%T", "Staff Mode Title in Admin", param);
}

public void AdminMenu_StaffMode(TopMenu topmenu, TopMenuAction action, TopMenuObject topobj_id, int param, char[] buffer, int maxlength)
{
	if (action == TopMenuAction_DisplayOption)
		Format(buffer, maxlength, "%T", "Staff Mode Buttom in Admin", param);
	else if (action == TopMenuAction_SelectOption)
		ShowMenu(param);
}

// PLUGIN

public void OnMapStart()
{
	// STEALTH
	
	g_iPlayerManager = FindEntityByClassname(-1, "cs_player_manager");
	
	if (g_iPlayerManager != -1)
		SDKHook(g_iPlayerManager, SDKHook_ThinkPost, Hook_PMThink);
	
	//CLEAR ARRAY
	
	staffemstaffmodes.Clear();
}

// CLIENT DISCONNECT

public void OnClientDisconnect(int client)
{
	// STEALTH
	
	g_bHideMe[client] = false;
	
	// JOIN AND LEAVE ANNOUNCER ON CHAT
	
	if (IsValidClient(client))
	{
		if (!StaffModes[client])
		{
			char name[MAX_NAME_LENGTH];
			GetClientName(client, name, sizeof(name));
			
			if (gConVar_Join_Leave_Message_Type.IntValue == 2)
			{
				CPrintToChatAll("%t", "Leave Message", name);
			}
		}
		
		if (StaffModes[client])
		{
			if (CheckCommandAccess(client, "sm_override_staff", ADMFLAG_GENERIC))
			{
				ExcludeCountServer--;
			}
		}
	}
}

// CLIENT CONNECT

public void OnClientPostAdminCheck(int client)
{
	// JOIN AND LEAVE ANNOUNCER ON CHAT
	
	if (IsValidClient(client))
	{
		if (CheckCommandAccess(client, "sm_override_staff", ADMFLAG_GENERIC))
		{
			OpenMenuStaff(client);
		}
		else
		{
			char name[MAX_NAME_LENGTH];
			GetClientName(client, name, sizeof(name));
			
			if (gConVar_Join_Leave_Message_Type.IntValue == 2)
			{
				CPrintToChatAll("%t", "Join Message", name);
			}
		}
	}
}

// JOIN STAFF MENU

public void OpenMenuStaff(int client)
{
	Menu menu = new Menu(MenuStaff);
	
	char Sim[128];
	char Nao[128];
	
	menu.SetTitle("%t", "Join Staff Menu Title");
	
	Format(Sim, sizeof(Sim), "%t", "Sim");
	menu.AddItem("1", Sim);
	
	Format(Nao, sizeof(Nao), "%t", "Nao");
	menu.AddItem("2", Nao);
	
	menu.ExitButton = false;
	menu.Display(client, MENU_TIME_FOREVER);
}

public int MenuStaff(Menu menu, MenuAction action, int client, int args)
{
	if (action == MenuAction_Select)
	{
		char selectedItem[200];
		menu.GetItem(args, selectedItem, sizeof(selectedItem));
		
		if (StrEqual(selectedItem, "1"))
		{
			StaffModes[client] = true;
			
			Command_StealthMode(client, 0);
			
			if (gConVar_Join_Leave_StaffMode.BoolValue)
				CPrintToChat(client, "%s %t", g_ChatPrefix, "Join Staff Mode");
			
			PickingMenu[client] = true;
			
			Wallhack(client, true);
			
			g_hideStaffList[client] = true;
			
			Call_StartForward(g_ExcludeForward);
			
			ExcludeCountServer++;
			
			staffemstaffmodes.Push(client);
		}
		else if (StrEqual(selectedItem, "2"))
		{
			char name[MAX_NAME_LENGTH];
			GetClientName(client, name, sizeof(name));
			
			if (gConVar_Join_Leave_Message_Type.IntValue == 2)
			{
				CPrintToChatAll("%t", "Join Message", name);
			}
		}
	}
}

// MODE STAFF MENU

public Action Staff_Mode(int client, int args)
{
	ShowMenu(client);
}

void ShowMenu(int client)
{
	char Fake1[128];
	char JoinCT1[128];
	char JoinT1[128];
	char JoinSPEC1[128];
	char Staffs[128];
	
	Menu menu = new Menu(Menu_Handler);
	
	if (gConVar_Staffs_Name_List.IntValue == 1 || gConVar_Staffs_Name_List.IntValue == 3)
	{
		if (staffemstaffmodes.Length != 0)
		{
			char allstaff[256];
			
			for (int i = 0; i < staffemstaffmodes.Length; i++)
			{
				int staff = staffemstaffmodes.Get(i);
				
				char name[MAX_NAME_LENGTH];
				GetClientName(staff, name, sizeof(name));
				
				Format(allstaff, sizeof(allstaff), "%s\n%s", allstaff, name);
			}
			
			Format(Staffs, sizeof(Staffs), "%s\n ", allstaff);
			
			menu.SetTitle("%t\n \n%t\n \n%s\n ", "Staff Mode Title", "Staff Mode Names", allstaff);
		}
		else
		{
			menu.SetTitle("%t\n \n%t\n \n%t\n ", "Staff Mode Title", "Staff Mode Names", "None");
		}
	}
	else
	{
		menu.SetTitle("%t\n ", "Staff Mode Title");
	}
	
	if (!StaffModes[client])
	{
		Format(Fake1, sizeof(Fake1), "%t", "Fake");
		menu.AddItem("Fake", Fake1);
	}
	else
	{
		Format(JoinCT1, sizeof(JoinCT1), "%t", "Join CT");
		menu.AddItem("CT", JoinCT1);
		
		Format(JoinT1, sizeof(JoinT1), "%t", "Join T");
		menu.AddItem("T", JoinT1);
		
		Format(JoinSPEC1, sizeof(JoinSPEC1), "%t", "Join SPEC");
		menu.AddItem("SPEC", JoinSPEC1);
	}
	
	menu.ExitButton = true;
	menu.Display(client, MENU_TIME_FOREVER);
}

public int Menu_Handler(Menu menu, MenuAction action, int client, int args)
{
	if (action == MenuAction_Select)
	{
		char selectedItem[200];
		menu.GetItem(args, selectedItem, sizeof(selectedItem));
		
		if (StrEqual(selectedItem, "Fake"))
		{
			StaffModes[client] = true;
			
			Command_StealthMode(client, 0);
			
			char name[128];
			GetClientName(client, name, sizeof(name));
			
			if (gConVar_Join_Leave_Message_Type.IntValue == 1)
			{
				PrintValveTranslationToAll(Destination_Chat, "#game_player_left_game", name, "#Player_DisconnectReason_Disconnect");
			}
			if (gConVar_Join_Leave_Message_Type.IntValue == 2)
			{
				CPrintToChatAll("%t", "Leave Message", name);
			}
			
			if (gConVar_Join_Leave_StaffMode.BoolValue)
				CPrintToChat(client, "%s %t", g_ChatPrefix, "Join Staff Mode");
			
			PickingMenu[client] = true;
			
			Wallhack(client, true);
			
			g_hideStaffList[client] = true;
			
			Call_StartForward(g_ExcludeForward);
			
			ExcludeCountServer++;
			
			staffemstaffmodes.Push(client);
		}
		
		if (StrEqual(selectedItem, "CT"))
		{
			StaffModes[client] = false;
			
			ChangeClientTeam(client, CS_TEAM_CT);
			
			char name[128];
			GetClientName(client, name, sizeof(name));
			
			if (gConVar_Join_Leave_Message_Type.IntValue == 1)
			{
				PrintValveTranslationToAll(Destination_Chat, "#Cstrike_game_join_ct", name);
			}
			if (gConVar_Join_Leave_Message_Type.IntValue == 2)
			{
				CPrintToChatAll("%t", "Join Message", name);
			}
			
			if (gConVar_Join_Leave_StaffMode.BoolValue)
				CPrintToChat(client, "%s %t", g_ChatPrefix, "Leave Staff Mode");
			
			PickingMenu[client] = false;
			
			Wallhack(client, false);
			
			g_hideStaffList[client] = false;
			
			Call_StartForward(g_ExcludeForward);
			
			ExcludeCountServer--;
			
			int index = staffemstaffmodes.FindValue(client);
			
			staffemstaffmodes.Erase(index);
		}
		
		if (StrEqual(selectedItem, "T"))
		{
			StaffModes[client] = false;
			
			ChangeClientTeam(client, CS_TEAM_T);
			
			char name[128];
			GetClientName(client, name, sizeof(name));
			
			if (gConVar_Join_Leave_Message_Type.IntValue == 1)
			{
				PrintValveTranslationToAll(Destination_Chat, "#Cstrike_game_join_terrorist", name);
			}
			if (gConVar_Join_Leave_Message_Type.IntValue == 2)
			{
				CPrintToChatAll("%t", "Join Message", name);
			}
			
			if (gConVar_Join_Leave_StaffMode.BoolValue)
				CPrintToChat(client, "%s %t", g_ChatPrefix, "Leave Staff Mode");
			
			PickingMenu[client] = false;
			
			Wallhack(client, false);
			
			g_hideStaffList[client] = false;
			
			Call_StartForward(g_ExcludeForward);
			
			ExcludeCountServer--;
			
			int index = staffemstaffmodes.FindValue(client);
			
			staffemstaffmodes.Erase(index);
		}
		
		if (StrEqual(selectedItem, "SPEC"))
		{
			StaffModes[client] = false;
			
			ChangeClientTeam(client, CS_TEAM_T);
			ChangeClientTeam(client, CS_TEAM_SPECTATOR);
			
			char name[128];
			GetClientName(client, name, sizeof(name));
			
			if (gConVar_Join_Leave_Message_Type.IntValue == 1)
			{
				PrintValveTranslationToAll(Destination_Chat, "#Cstrike_game_join_spectators", name);
			}
			if (gConVar_Join_Leave_Message_Type.IntValue == 2)
			{
				CPrintToChatAll("%t", "Join Message", name);
			}
			
			if (gConVar_Join_Leave_StaffMode.BoolValue)
				CPrintToChat(client, "%s %t", g_ChatPrefix, "Leave Staff Mode");
			
			PickingMenu[client] = false;
			
			Wallhack(client, false);
			
			g_hideStaffList[client] = false;
			
			Call_StartForward(g_ExcludeForward);
			
			ExcludeCountServer--;
			
			int index = staffemstaffmodes.FindValue(client);
			
			staffemstaffmodes.Erase(index);
		}
	}
	else if (action == MenuAction_End)
	{
		delete menu;
	}
}

// REMOVER MENSAGENS DEFAULT BRANCAS

public Action OnPlayerTeam1(Handle event, char[] name, bool dontBroadcast)
{
	if (gConVar_Join_Leave_Message_Type.IntValue == 0 || gConVar_Join_Leave_Message_Type.IntValue == 2)
		return Plugin_Handled;
	
	return Plugin_Continue;
}

public Action OnPlayerDisconnect1(Handle event, char[] name, bool dontBroadcast)
{
	int client = GetClientOfUserId(GetEventInt(event, "userid"));
	
	if (gConVar_Join_Leave_Message_Type.IntValue == 0 || gConVar_Join_Leave_Message_Type.IntValue == 2)
	{
		return Plugin_Handled;
	}
	
	if (gConVar_Join_Leave_Message_Type.IntValue == 1)
	{
		if (StaffModes[client])
		{
			return Plugin_Handled;
		}
	}
	
	return Plugin_Continue;
}

// WALLHACK

public bool Wallhack(int client, bool value)
{
	SendConVarValue(client, sv_competitive_official_5v5, value ? "1" : "0");
}

// STEALTH

public Action Command_StealthMode(int client, int args)
{
	if (!client)
		return Plugin_Handled;
	
	if (!g_bHideMe[client])
	{
		g_bHideMe[client] = true;
		
		if (GetClientTeam(client) != CS_TEAM_SPECTATOR && GetConVarInt(sm_stealth_autoswitch) == 1)
			ChangeClientTeam(client, CS_TEAM_SPECTATOR);
	}
	else
		g_bHideMe[client] = false;
	
	return Plugin_Continue;
}

public Action Event_OnPlayerTeam(Handle event, const char[] name, bool dontBroadcast)
{
	int client = GetClientOfUserId(GetEventInt(event, "userid"));
	if (g_bHideMe[client])
	{
		if (g_bHideMe[client] && GetConVarInt(sm_stealth_disable_switch) == 1 && GetConVarInt(sm_stealth_autoswitch) == 1 && GetClientTeam(client) == CS_TEAM_SPECTATOR)
			g_bHideMe[client] = false;
		
		SetEventBroadcast(event, true);
		return Plugin_Changed;
	}
	
	return Plugin_Continue;
}

public void Hook_PMThink(int entity)
{
	for (int i = 1; i <= MaxClients; i++)
	{
		if (IsClientInGame(i) && g_bHideMe[i])
		{
			SetEntData(g_iPlayerManager, g_iAliveOffset + (i * 4), false, 4, true);
			SetEntData(g_iPlayerManager, g_iConnectedOffset + (i * 4), false, 4, true);
			SetEntData(g_iPlayerManager, g_iTeamOffset + (i * 4), 0, 4, true);
			SetEntData(g_iPlayerManager, g_iPingOffset + (i * 4), 0, 4, true);
			SetEntData(g_iPlayerManager, g_iScoreOffset + (i * 4), 0, 4, true);
			SetEntData(g_iPlayerManager, g_iDeathsOffset + (i * 4), 0, 4, true);
			SetEntData(g_iPlayerManager, g_iHealthOffset + (i * 4), 0, 4, true);
		}
	}
}

public void OnGameFrame()
{
	for (int i = 1; i <= MaxClients; i++)
	{
		if (IsClientInGame(i) && g_bHideMe[i])
		{
			SetEntData(g_iPlayerManager, g_iAliveOffset + (i * 4), false, 4, true);
			SetEntData(g_iPlayerManager, g_iConnectedOffset + (i * 4), false, 4, true);
			SetEntData(g_iPlayerManager, g_iTeamOffset + (i * 4), 0, 4, true);
			SetEntData(g_iPlayerManager, g_iPingOffset + (i * 4), 0, 4, true);
			SetEntData(g_iPlayerManager, g_iScoreOffset + (i * 4), 0, 4, true);
			SetEntData(g_iPlayerManager, g_iDeathsOffset + (i * 4), 0, 4, true);
			SetEntData(g_iPlayerManager, g_iHealthOffset + (i * 4), 0, 4, true);
		}
	}
}



// STAFF EM STAFF MODES ARRAY

public Action OnPlayerRunCmd(int client, int & buttons, int & impulse, float vel[3], float angles[3], int & weapon, int & subtype, int & cmdnum, int & tickcount, int & seed, int mouse[2])
{
	if (IsValidClient(client))
	{
		if (gConVar_Staffs_Name_List.IntValue == 2 || gConVar_Staffs_Name_List.IntValue == 3)
		{
			if (buttons & IN_SCORE)
			{
				if (CheckCommandAccess(client, "sm_override_staff", ADMFLAG_GENERIC))
				{
					RenderHUD(client);
				}
			}
			else
			{
				ClearSyncHud(client, hHudText);
			}
		}
	}
}

stock void RenderHUD(int client)
{
	if (IsValidClient(client))
	{
		if (staffemstaffmodes.Length != 0)
		{
			char allstaff[256];
			
			for (int i = 0; i < staffemstaffmodes.Length; i++)
			{
				int staff = staffemstaffmodes.Get(i);
				
				char name[MAX_NAME_LENGTH];
				GetClientName(staff, name, sizeof(name));
				
				Format(allstaff, sizeof(allstaff), "%s\n%s", allstaff, name);
			}
			
			SetHudTextParams(0.25, 0.72, 60.0, 255, 255, 255, 255);
			ShowSyncHudText(client, hHudText, "%t\n%s", "Staff Mode Names", allstaff);
		}
		else
		{
			SetHudTextParams(0.25, 0.72, 60.0, 255, 255, 255, 255);
			ShowSyncHudText(client, hHudText, "%t\n \n%t", "Staff Mode Names", "None");
		}
	}
}

// PICKING TEAM MENU WITH CHAT MESSAGE AND DISABLE WALLHACK

public void Event_OnPlayerTeam1(Event event, const char[] name, bool dontBroadcast)
{
	int client = GetClientOfUserId(GetEventInt(event, "userid"));
	
	if (IsValidClient(client))
		CreateTimer(0.1, Timer_DelayTeam, GetClientUserId(client), TIMER_FLAG_NO_MAPCHANGE);
}

public Action Timer_DelayTeam(Handle timer, any data)
{
	int client = GetClientOfUserId(data);
	
	if (!PickingMenu[client])
	{
		return Plugin_Handled;
	}
	else if (GetClientTeam(client) == CS_TEAM_CT)
	{
		StaffModes[client] = false;
		
		char name[128];
		GetClientName(client, name, sizeof(name));
		
		if (gConVar_Join_Leave_Message_Type.IntValue == 1)
		{
			PrintValveTranslationToAll(Destination_Chat, "#Cstrike_game_join_ct", name);
		}
		if (gConVar_Join_Leave_Message_Type.IntValue == 2)
		{
			CPrintToChatAll("%t", "Join Message", name);
		}
		
		if (gConVar_Join_Leave_StaffMode.BoolValue)
			CPrintToChat(client, "%s %t", g_ChatPrefix, "Leave Staff Mode");
		
		PickingMenu[client] = false;
		
		Wallhack(client, false);
		
		g_hideStaffList[client] = false;
		
		Call_StartForward(g_ExcludeForward);
		
		ExcludeCountServer--;
		
		int index = staffemstaffmodes.FindValue(client);
		
		staffemstaffmodes.Erase(index);
	}
	else if (GetClientTeam(client) == CS_TEAM_T)
	{
		StaffModes[client] = false;
		
		char name[128];
		GetClientName(client, name, sizeof(name));
		
		if (gConVar_Join_Leave_Message_Type.IntValue == 1)
		{
			PrintValveTranslationToAll(Destination_Chat, "#Cstrike_game_join_terrorist", name);
		}
		if (gConVar_Join_Leave_Message_Type.IntValue == 2)
		{
			CPrintToChatAll("%t", "Join Message", name);
		}
		
		if (gConVar_Join_Leave_StaffMode.BoolValue)
			CPrintToChat(client, "%s %t", g_ChatPrefix, "Leave Staff Mode");
		
		PickingMenu[client] = false;
		
		Wallhack(client, false);
		
		g_hideStaffList[client] = false;
		
		Call_StartForward(g_ExcludeForward);
		
		ExcludeCountServer--;
		
		int index = staffemstaffmodes.FindValue(client);
		
		staffemstaffmodes.Erase(index);
	}
	return Plugin_Continue;
}

// CallAdmin_OnDrawTarget

public Action CallAdmin_OnDrawTarget(int client, int target)
{
	return StaffModes[target] ? Plugin_Handled : Plugin_Continue;
}

// DISABLE PING AND STATUS ON CONSOLA

public Action ExecuteStringCommand(int client, char sCommandString[512])
{
	if (IsValidClient(client))
	{
		char message[512];
		strcopy(message, sizeof(message), sCommandString);
		TrimString(message);
		
		if (gConVar_StatusPing.BoolValue && CheckCommandAccess(client, "sm_override_staff", ADMFLAG_GENERIC, true))
		{
			if (StrContains(message, "status ") == 0 || StrEqual(message, "status", false))
			{
				return Plugin_Continue;
			}
			
			if (StrContains(message, "ping ") == 0 || StrEqual(message, "ping", false))
			{
				return Plugin_Continue;
			}
		}
		else
		{
			if (StrContains(message, "status ") == 0 || StrEqual(message, "status", false))
			{
				return Plugin_Handled;
			}
			
			if (StrContains(message, "ping ") == 0 || StrEqual(message, "ping", false))
			{
				return Plugin_Handled;
			}
		}
		
	}
	return Plugin_Continue;
}

// REMOVE STAFF NICKSNAMES ON COMMUNITY SERVERS LIST

public APLRes AskPluginLoad2(Handle plugin, bool late, char[] error, int err_max)
{
	RegPluginLibrary("S2AProxy");
}

int GetInfoPlayersIndex(const int[] bytes)
{
	int cursor = 6;
	int strings;
	
	do
	{
		if (bytes[cursor] == '\0')
			strings++;
		
		cursor++;
	} while (strings < 4);
	
	cursor += 2;
	return cursor;
}

int RetrieveData(const int[] bytes, int[] out)
{
	int cursor = 5;
	int outCursor;
	int players = bytes[cursor];
	int outPlayers;
	
	out[0] = 0xFF;
	out[1] = 0xFF;
	out[2] = 0xFF;
	out[3] = 0xFF;
	out[4] = 0x44;
	out[5] = players;
	outCursor += 6;
	
	cursor++;
	for (int i = 0; i < players; i++)
	{
		char name[MAX_NAME_LENGTH];
		int nameLength;
		
		do
		{
			name[nameLength] = bytes[cursor + 1 + nameLength];
			nameLength++;
		} while (bytes[cursor + nameLength] != '\0');
		
		Action result;
		Call_StartForward(g_ExcludeForward);
		Call_PushString(name);
		Call_Finish(result);
		
		if (result == Plugin_Handled || result == Plugin_Stop)
		{
			cursor += nameLength + 1 + 4 + 4;
			continue;
		}
		
		outPlayers++;
		nameLength = 0;
		
		out[outCursor] = bytes[cursor];
		cursor++;
		outCursor++;
		
		do
		{
			out[outCursor + nameLength] = bytes[cursor + nameLength];
			nameLength++;
		} while (bytes[cursor + nameLength] != '\0');
		
		cursor += nameLength + 1;
		outCursor += nameLength + 1;
		
		out[outCursor] = bytes[cursor];
		out[outCursor + 1] = bytes[cursor + 1];
		out[outCursor + 2] = bytes[cursor + 2];
		out[outCursor + 3] = bytes[cursor + 3];
		cursor += 4;
		outCursor += 4;
		
		out[outCursor] = bytes[cursor];
		out[outCursor + 1] = bytes[cursor + 1];
		out[outCursor + 2] = bytes[cursor + 2];
		out[outCursor + 3] = bytes[cursor + 3];
		cursor += 4;
		outCursor += 4;
	}
	
	out[5] = outPlayers;
	return outCursor;
}

public MRESReturn Detour_OnNetSendPacket(Handle hReturn, Handle hParams)
{
	Address strAddress = DHookGetParam(hParams, 3);
	int size = DHookGetParam(hParams, 4);
	int bytes[512];
	
	int packetHeader = LoadFromAddress(strAddress + view_as<Address>(4), NumberType_Int8);
	
	if (packetHeader != 0x44 && packetHeader != 0x49)
		return MRES_Ignored;
	
	for (int i = 0; i < size; i++)
	{
		int val = LoadFromAddress(strAddress + view_as<Address>(i), NumberType_Int8);
		bytes[i] = val;
	}
	
	if (packetHeader == 0x44)
	{
		int newData[512];
		int newSize = RetrieveData(bytes, newData);
		for (int i = 0; i < newSize; i++)
		{
			StoreToAddress(strAddress + view_as<Address>(i), newData[i], NumberType_Int8);
		}
		DHookSetParam(hParams, 4, newSize);
	}
	else if (packetHeader == 0x49)
	{
		int playersIndex = GetInfoPlayersIndex(bytes);
		int playerCount = LoadFromAddress(strAddress + view_as<Address>(playersIndex), NumberType_Int8);
		int excludeCount = 0;
		
		Action result;
		Call_StartForward(g_ExcludeCountForward);
		Call_PushCellRef(excludeCount);
		Call_Finish(result);
		
		if (excludeCount < 0)
			excludeCount = 0;
		
		if (excludeCount > playerCount)
			excludeCount = playerCount;
		
		if (result == Plugin_Changed)
			StoreToAddress(strAddress + view_as<Address>(playersIndex), playerCount - excludeCount, NumberType_Int8);
	}
	return MRES_ChangedHandled;
}

public Action OnClientPlayerList(const char[] playerName)
{
	int client = GetPlayerIndexByName(playerName);
	
	if (client == -1)
	{
		return Plugin_Continue;
	}
	
	return g_hideStaffList[client] ? Plugin_Handled : Plugin_Continue;
}

public int GetPlayerIndexByName(const char[] name)
{
	for (int i = 1; i <= MaxClients; i++)
	{
		if (IsValidClient(i))
		{
			char buff[MAX_NAME_LENGTH];
			GetClientName(i, buff, sizeof(buff));
			
			if (!strcmp(name, buff) || StrEqual(buff, name))
			{
				return i;
			}
		}
	}
	return -1;
}

public Action OnServerExcludeCount(int &excludeCount)
{
	excludeCount = ExcludeCountServer;
	
	return Plugin_Changed;
}

// ISVALIDCLIENT

stock bool IsValidClient(int client)
{
	return (1 <= client <= MaxClients && IsClientInGame(client) && !IsClientSourceTV(client) && !IsFakeClient(client));
} 